indexing

	description:

		"Reader where source is a similar reader.  No conversions,%
		%one object in for one out. You probably want to redefine `read'."

	library: "Gobo Eiffel Pipework Library"
	copyright: "Copyright (c) 2001, Simon Parker and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: $"
	revision: "$Revision: $"


class

	PW_READER_READER [OUTWARD]


inherit

	PW_TRANSFORMING_READER [OUTWARD]
		redefine
			source
		end


creation

	make,
	connect


feature -- Access

	source: PW_READER [OUTWARD]
			-- Inlet


feature -- Reading

	last_item: OUTWARD is
			-- Result of last successful read
		do
			Result := source.last_item
		end

	read is
			-- Try to read one from source.
		do
			source.read
			copy_error_from_source
		end

end
